%define with_dri 1
%define dri_target linux-dri-x86
%define src_dirs SRC_DIRS="glx/x11 mesa glu"

%define manpages gl-manpages-1.0.1

%define with_hardware 1
%define relc

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Mesa graphics libraries
Name: 		mesa
Version: 	7.9
Release: 	4
Epoch:		1
License: 	MIT/X11
Group: 		System/Libraries
URL: 		http://www.mesa3d.org
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}%{?relc:-rc%{relc}}-buildroot
BuildArch:	i686
Source0:	MesaLib-%{version}%{?relc:-rc%{relc}}.tar.bz2
Source2: 	%{manpages}.tar.bz2
Patch0:		mesa-7.9-libdrm-2.4.23-nouveau-api.patch
BuildRequires: 	pkg-config
BuildRequires: 	libdrm-devel >= 2.4.22-1
BuildRequires: 	xorg-x11-proto-devel >= 7.3
BuildRequires:  xorg-x11-server-sdk
BuildRequires:  pixman-devel
BuildRequires:  libpciaccess-devel
BuildRequires: 	makedepend
BuildRequires:  talloc-devel

BuildRequires: glew-devel
BuildRequires: libXrender-devel
BuildRequires: python26-devel
BuildRequires: libxml2-python
BuildRequires: libxml2-devel

#Automatically resolved build dependencies
BuildRequires: expat-devel
BuildRequires: freeglut-devel
BuildRequires: glibc-devel
BuildRequires: libgcc
BuildRequires: libstdc++-devel
BuildRequires: libX11-devel
BuildRequires: libxcb-devel
BuildRequires: libXdamage-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXt-devel
BuildRequires: libXxf86vm-devel
BuildRequires: lesstif-devel

# prevent the propietary openGL incarnations
#BuildConflicts: xorg-x11-drv-fglrx
#BuildConflicts: xorg-x11-drv-nvidia
#BuildConflicts: xorg-x11-drv-nvidia-legacy
#BuildConflicts: xorg-x11-drv-nvidia-legacy96xx

%description
Mesa

%package libGL
Summary: Mesa libGL runtime libraries and DRI drivers
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Provides: libGL
Requires: libdrm >= 2.4.21-1
%if %{with_hardware}
Conflicts: xorg-x11-server-Xorg < 1.4.99.901-14
%endif

%description libGL
Mesa libGL runtime library.

%package libEGL
Summary: Mesa libEGL runtime libraries
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Requires: mesa-dri-drivers%{?_isa} = %{epoch}:%{version}-%{release}
Requires: libdrm >= 2.4.21-1

%description libEGL
Mesa libEGL runtime libraries

%package libGLES
Summary: Mesa libGLES runtime libraries
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Requires: mesa-dri-drivers%{?_isa} = %{epoch}:%{version}-%{release}
Requires: libdrm >= 2.4.21-1

%description libGLES
Mesa GLES runtime libraries

%package dri-drivers
Summary: Mesa-based DRI drivers
Group: User Interface/X Hardware Support
%description dri-drivers
Mesa-based DRI drivers.


%package dri-drivers-experimental
Summary: Mesa-based DRI drivers (experimental)
Group: User Interface/X Hardware Support
%description dri-drivers-experimental
Mesa-based DRI drivers (experimental).


%package libGL-devel
Summary: Mesa libGL development package
Group: Development/Libraries
Requires: mesa-libGL = %{epoch}:%{version}-%{release}
Requires: libX11-devel
Provides: libGL-devel
Conflicts: xorg-x11-proto-devel <= 7.2-12

%description libGL-devel
Mesa libGL development package

%package libEGL-devel
Summary: Mesa libEGL development package
Group: Development/Libraries
Requires: mesa-libEGL = %{epoch}:%{version}-%{release}

%description libEGL-devel
Mesa libEGL development package

%package libGLES-devel
Summary: Mesa libGLES development package
Group: Development/Libraries
Requires: mesa-libGLES = %{epoch}:%{version}-%{release}

%description libGLES-devel
Mesa libGLES development package

%package libGLU
Summary: Mesa libGLU runtime library
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Provides: libGLU

%description libGLU
Mesa libGLU runtime library


%package libGLU-devel
Summary: Mesa libGLU development package
Group: Development/Libraries
Requires: mesa-libGLU = %{epoch}:%{version}-%{release}
Requires: libGL-devel
Provides: libGLU-devel

%description libGLU-devel
Mesa libGLU development package


%package libOSMesa
Summary: Mesa offscreen rendering libraries
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Provides: libOSMesa

%description libOSMesa
Mesa offscreen rendering libraries


%package libOSMesa-devel
Summary: Mesa offscreen rendering development package
Group: Development/Libraries
Requires: mesa-libOSMesa = %{epoch}:%{version}-%{release}

%description libOSMesa-devel
Mesa offscreen rendering development package


%package -n xorg-x11-drv-vmwgfx
Summary: VMware GFX DDX driver
Group: User Interface/X Hardware Support
Requires: xorg-x11-server-Xorg

%description -n xorg-x11-drv-vmwgfx
2D driver for VMware SVGA vGPU

%package libOpenVG
Summary: Mesa libOpenVG runtime library
Group: System Environment/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Requires: mesa-dri-drivers = %{epoch}:%{version}-%{release}

%description libOpenVG
Mesa libOpenVG runtime library


%package libOpenVG-devel
Summary: Mesa libOpenVG development package
Group: Development/Libraries
Requires: mesa-libOpenVG = %{epoch}:%{version}-%{release}

%description libOpenVG-devel
Mesa libOpenVG development package

%prep
%setup -q -n Mesa-%{version}%{?relc:-rc%{relc}} -b2
%patch0 -p1
mkdir python-bin
ln -s /usr/bin/python2.6 python-bin/python

%build
export PATH="$PATH:$(pwd)/python-bin"

rm -f src/mesa/depend  
export TALLOC_LIBS=-ltalloc  
export TALLOC_CFLAGS="-I/usr/include"  
autoreconf -fi 

#utoreconf --install

export CFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer"

%ifarch %{ix86}
# i do not have words for how much the assembly dispatch code infuriates me
%define common_flags --disable-selinux --enable-pic --disable-asm
%else
%define common_flags --disable-selinux --enable-pic
%endif
%define osmesa_flags --with-driver=osmesa %{common_flags} --disable-gallium --with-dri-drivers="" --disable-glu --disable-egl

%configure %{osmesa_flags} --with-osmesa-bits=8
make %{_smp_mflags}
mv %{_lib} osmesa8
make clean

# just to be sure...
[ `find . -name \*.o | wc -l` -eq 0 ] || exit 1

# now build the rest of mesa
# disabled nouveau as libdrm and mesa don`t match right now
./configure %{common_flags} \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --disable-glw \
    --disable-glut \
    --disable-gl-osmesa \
    --with-driver=dri \
    --with-dri-driverdir=%{_libdir}/dri \
    --with-state-trackers=dri,glx,egl,vega,xorg \
    --enable-egl \
    --enable-gles1 \
    --enable-gles2 \
    --enable-gallium-llvm \
    --enable-openvg \
    --disable-gallium-intel \
    --disable-gallium-svga \
    --enable-gallium-radeon \
    --enable-gallium-r600 \
    --enable-gallium-nouveau \
    %{?dri_drivers}

make #{?_smp_mflags}

pushd ../%{manpages}
autoreconf -v --install
%configure
make %{?_smp_mflags}
popd


%install
export PATH="$PATH:$(pwd)/python-bin"
rm -rf $RPM_BUILD_ROOT

# core libs and headers, but not drivers.
make install DESTDIR=$RPM_BUILD_ROOT DRI_DIRS=

# just the DRI drivers that are sane
install -d $RPM_BUILD_ROOT%{_libdir}/dri
#install -m 0755 -t $RPM_BUILD_ROOT%{_libdir}/dri %{_lib}/libdricore.so >& /dev/null
# use gallium driver iff built
[ -f %{_lib}/gallium/r300_dri.so ] && cp %{_lib}/gallium/r300_dri.so %{_lib}/r300_dri.so
[ -f %{_lib}/gallium/r600_dri.so ] && cp %{_lib}/gallium/r600_dri.so %{_lib}/r600_dri.so
[ -f %{_lib}/gallium/swrastg_dri.so ] && mv %{_lib}/gallium/swrastg_dri.so %{_lib}/swrast_dri.so
for f in i810 i915 i965 mach64 mga r128 r200 r300 r600 radeon savage sis swrast tdfx unichrome nouveau_vieux gallium/vmwgfx; do
    so=%{_lib}/${f}_dri.so
    test -e $so && echo $so
done | xargs install -m 0755 -t $RPM_BUILD_ROOT%{_libdir}/dri >& /dev/null || :

# strip out undesirable headers
pushd $RPM_BUILD_ROOT%{_includedir}/GL
rm [a-fh-np-wyz]*.h glf*.h
#rm [a-fh-np-wyz]*.h glf*.h glut*.h
popd

pushd $RPM_BUILD_ROOT%{_libdir}
rm -f xorg/modules/drivers/modesetting_drv.so
popd

# and osmesa
mv osmesa*/libOS* $RPM_BUILD_ROOT%{_libdir}

# man pages
pushd ../%{manpages}
make %{?_smp_mflags} install DESTDIR=$RPM_BUILD_ROOT
popd

# this keeps breaking, check it early.  note that the exit from eu-ftr is odd.
pushd $RPM_BUILD_ROOT%{_libdir}
for i in libOSMesa*.so libGL.so ; do
    eu-findtextrel $i && exit 1
done
popd

%clean
rm -rf $RPM_BUILD_ROOT
%check

%post libGL -p /sbin/ldconfig
%postun libGL -p /sbin/ldconfig
%post libGLU -p /sbin/ldconfig
%postun libGLU -p /sbin/ldconfig
%post libOSMesa -p /sbin/ldconfig
%postun libOSMesa -p /sbin/ldconfig
%post libEGL -p /sbin/ldconfig
%postun libEGL -p /sbin/ldconfig
%post libGLES -p /sbin/ldconfig
%postun libGLES -p /sbin/ldconfig

%files libGL
%defattr(-,root,root,-)
%doc docs/COPYING
%{_libdir}/libGL.so.1
%{_libdir}/libGL.so.1.*

%files libEGL
%defattr(-,root,root,-)
%doc docs/COPYING
%{_libdir}/libEGL.so.1
%{_libdir}/libEGL.so.1.*
%{_libdir}/egl/egl_glx.so
%{_libdir}/egl/egl_dri2.so
%{_libdir}/egl/egl_gallium.so
%{_libdir}/egl/pipe_nouveau.so
%{_libdir}/egl/pipe_r300.so
%{_libdir}/egl/pipe_r600.so
%{_libdir}/egl/pipe_swrast.so
%{_libdir}/egl/st_GL.so

%files libGLES
%defattr(-,root,root,-)
%doc docs/COPYING
%{_libdir}/libGLESv1_CM.so.1
%{_libdir}/libGLESv1_CM.so.1.*
%{_libdir}/libGLESv2.so.2
%{_libdir}/libGLESv2.so.2.*

%files libOpenVG
%defattr(-,root,root,-)
%doc docs/COPYING
%{_libdir}/egl/st_OpenVG.so
%{_libdir}/libOpenVG.so.1
%{_libdir}/libOpenVG.so.1.0.0

%files dri-drivers
%defattr(-,root,root,-)
%doc docs/COPYING
%dir %{_libdir}/dri
#%{_libdir}/dri/libdricore.so
%{_libdir}/dri/*_dri.so
%exclude %{_libdir}/dri/swrastg_dri.so
%if %{with_hardware}
#exclude %{_libdir}/dri/vmwgfx_dri.so
%exclude %{_libdir}/dri/nouveau_dri.so
#%exclude %{_libdir}/dri/nouveau_vieux_dri.so
# xorg-x11-drv-ati packages this, so exclude it here
%exclude /usr/lib/xorg/modules/drivers/radeon_drv.so
%endif

%files dri-drivers-experimental
%defattr(-,root,root,-)
%doc docs/COPYING
%if %{with_hardware}
#{_libdir}/dri/vmwgfx_dri.so
%{_libdir}/dri/nouveau_dri.so
#%{_libdir}/dri/nouveau_vieux_dri.so
%endif

%files libGL-devel
%defattr(-,root,root,-)
%{_includedir}/GL/gl.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/glx.h
%{_includedir}/GL/glx_mangle.h
%{_includedir}/GL/glxext.h
%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/dri_interface.h
%{_libdir}/pkgconfig/dri.pc
%{_libdir}/libGL.so
%{_libdir}/pkgconfig/gl.pc
%{_datadir}/man/man3/gl[^uX]*.3gl*
%{_datadir}/man/man3/glX*.3gl*

%files libEGL-devel
%defattr(-,root,root,-)
%{_includedir}/EGL/eglext.h
%{_includedir}/EGL/egl.h
%{_includedir}/EGL/eglplatform.h
%{_includedir}/KHR/khrplatform.h
%{_libdir}/pkgconfig/egl.pc
%{_libdir}/libEGL.so

%files libGLES-devel
%defattr(-,root,root,-)
%{_includedir}/GLES/egl.h
%{_includedir}/GLES/gl.h
%{_includedir}/GLES/glext.h
%{_includedir}/GLES/glplatform.h
%{_includedir}/GLES2/gl2platform.h
%{_includedir}/GLES2/gl2.h
%{_includedir}/GLES2/gl2ext.h
%{_libdir}/pkgconfig/glesv1_cm.pc
%{_libdir}/pkgconfig/glesv2.pc
%{_libdir}/libGLESv1_CM.so
%{_libdir}/libGLESv2.so

%files libOpenVG-devel
%defattr(-,root,root,-)
%{_includedir}/VG/openvg.h
%{_includedir}/VG/vgext.h
%{_includedir}/VG/vgplatform.h
%{_includedir}/VG/vgu.h
%{_libdir}/libOpenVG.so
%{_libdir}/pkgconfig/vg.pc

%files libGLU
%defattr(-,root,root,-)
%{_libdir}/libGLU.so.1
%{_libdir}/libGLU.so.1.3.*

%files libGLU-devel
%defattr(-,root,root,-)
%{_libdir}/libGLU.so
%{_libdir}/pkgconfig/glu.pc
%{_includedir}/GL/glu.h
%{_includedir}/GL/glu_mangle.h
%{_datadir}/man/man3/glu*.3gl*

%files libOSMesa
%defattr(-,root,root,-)
%doc docs/COPYING
%{_libdir}/libOSMesa.so.7*

%files libOSMesa-devel
%defattr(-,root,root,-)
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so

%changelog
* Thu Dec 16 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.9-4
- rebuilt against libdrm 2.4.23 
* Wed Dec 08 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.9-3
- rebuilt
* Fri Nov 19 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.9-2
- added libEGL, libGLES 
* Tue Oct 05 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.9-1
- Version update
- mesa demos have a separate specfile now
* Sat Aug 14 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.8.2-2
- rebuilt
* Sun Jun 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.8.2-1
- Version update
* Mon Apr 05 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.8.1-1
- Version update
* Mon Mar 29 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:7.8-1
- Version update
* Wed Dec 23 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:7.7-1
- Version update
- dropped s3v, trident support
* Mon Nov 23 2009 Stefan Gottwald <gotti@ccux-linux.de> 1:7.6-2
- enabled r600 support
* Mon Oct 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:7.6-1
- Version update
* Fri Sep 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:7.5.1-1
- Version update
* Sun Aug 09 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:7.5-3
- added epoch=1 to fix libGLw update dilemma
- added BuildConflicts with propietary OpenGL implementations
* Fri Aug 07 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.5-2
- rebuilt against libdrm 2.4.12 
* Sun Jul 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.5-1
- Version update
* Sat Jul 11 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4.4-1
- Version update
* Fri May 21 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4.2-2
- rebuilt
* Wed May 20 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4.2-1
- Version update
* Thu Apr 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4.1-1
- Version update
* Wed Apr 15 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4-2
- rebuilt against libdrm 2.4.9
* Tue Mar 31 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.4-1
- Version update
* Fri Feb 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.3-5
- rebuilt against libdrm 2.4.5
* Fri Jan 23 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.3-4
- final version
* Wed Jan 21 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.3-3
- rc3
* Thu Jan 15 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.3-2
- rc2
* Tue Jan 13 2009 Karsten Brockmann <arcam@ccux-linux.de> 7.3-1
- Version update, rc1
* Sun Sep 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 7.2-1
- Version update
* Sun Sep 07 2008 Stefan Gottwald <gotti@ccux-linux.de> 7.1-2
- switch to official Mesa-7.1 tarballs
* Sat Jan 05 2008 Christian Metzen <metzench@ccux-linux.de> 7.1-1
- Version update
- moved libGlw to own package
* Mon Nov 12 2007 Stefan Gottwald <gotti@ccux-linux.de> 7.0.2-1
- version update
- used later git version as official tarballs won't compile
* Wed Oct 10 2007 Christian Metzen <metzench@ccux-linux.de> 7.0.1-2
- cleaned specfile, corrected package group for libOSMesa
* Mon Aug 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 7.0.1-1
- Version update
* Tue Jun 26 2007 Stefan Gottwald <gotti@ccux-linux.de> 7.0-2
- added xcb and nptl support patch
* Sat Jun 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 7.0-1
- Version update
* Mon Jun 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.3-2
- reapplied Gottis remove-debug-symbols-patch
* Mon Jun 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.3-1
- Version update
* Sun Feb 18 2007 Karsten Brockmann <arcam@ccux-linux.de> 6.5.2-1
- Version update
* Fri Jan 26 2007 Stefan Gottwald <gotti@ccux-linux.de> 6.5.1-3
- removed mach64 from build because problems with libdrm > 2.0.2
- added patch to disable debug symbols in DRI Modules
* Mon Sep 11 2006 Christian Metzen <metzench@ccux-linux.de> 6.5.1-2
- adjusted obsoletes
* Sun Sep 10 2006 Christian Metzen <metzench@ccux-linux.de> 6.5.1-1
- Version update
* Sat Jul 01 2006 Christian Metzen <metzench@ccux-linux.de> 6.5-1
- Initial release
